(function($) {
	$.extend({
		// Konsolen-Log
		clog: function(str) {
			if (window.console) console.log(str); else alert(str);
		},
		
		// String in UTF-8 encoden
		utf_encode: function (s) {
			for(var c, i = -1, l = (s = s.split("")).length, o = String.fromCharCode; ++i < l;
				s[i] = (c = s[i].charCodeAt(0)) >= 127 ? o(0xc0 | (c >>> 6)) + o(0x80 | (c & 0x3f)) : s[i]
			);
			return s.join("");
		},
		
		// String in UTF-8 decoden
		utf_decode: function (s) {
			for(var a, b, i = -1, l = (s = s.split("")).length, o = String.fromCharCode, c = "charCodeAt"; ++i < l;
				((a = s[i][c](0)) & 0x80) &&
				(s[i] = (a & 0xfc) == 0xc0 && ((b = s[i + 1][c](0)) & 0xc0) == 0x80 ?
				o(((a & 0x03) << 6) + (b & 0x3f)) : o(128), s[++i] = "")
			);
			return s.join("");
		},
		
		// Alle GET-Variablen in ein Objekt speichern
		getUrlVars: function(){
			var vars = [], hash;
			var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
			for(var i = 0; i < hashes.length; i++)
			{
			  hash = hashes[i].split('=');
			  vars.push(hash[0]);
			  vars[hash[0]] = hash[1];
			}
			return vars;
		},
		
		// Bestimmte GET-Variable in ein Objekt speichern
		getUrlVar: function(name){
			return $.getUrlVars()[name];
		},
		
		// Mouseover- und -out-Effekt fuer die Tabelle
		tableHover: function(options) {
			// Standardsettings,  falls sie nicht im Objekt beim Aufruf mitgegeben wurden
			var settings = {
				selector:  "#ezStats table.sort tr, #ezDetail table.sort tr", // Elemente auf denen die Funktion ausgefhrt werden soll
				className: "hover"  // Name der Klasse, die hinzugefgt oder entfernt werden soll
			}
			
			// Falls mit den Optionen kein Objekt uebergeben wird, wird angenommen dass es der Wert fuer "id" ist 
			if (typeof(options) != "object" && options != undefined ) options = {id: options};
			var cfg = $.extend({}, settings, options);
			
			$(document).on("mouseover mouseout", cfg.selector, function(event) {
				if (event.type == "mouseover") $(this).addClass(cfg.className);
				if (event.type == "mouseout")  $(this).removeClass(cfg.className);
			});
		},
		
		// Erstellt ein Tooltipp
		tooltipp: function(options) {
			// Standardsettings,  falls sie nicht im Objekt beim Aufruf mitgegeben wurden
			var settings = {
				selector:  "#ezStats [info], #ezDetail [info]",   // Elemente auf denen die Funktion ausgefhrt werden soll
				id: "bubble",          // ID die der Tooltipp erhaelt
				attr: "info",          // Attribut, in dem die Daten stehen
				arrow: 10,             // Groesse des "Pfeils" unter dem Tooltipp
				openOn: "mouseover",   // Event da das Tooltipp startet
				closeOn: "mouseout",   // Event da das Tooltipp beendet
				position: "top",       // Position des Tooltipps (top = ueber dem Element, bottom = unter dem Element, middle = auf dem Element)
				utf8: false            // Angabe ob der uebergebene Text UTF8-encodiert ist
			}
			
			// Falls mit den Optionen kein Objekt uebergeben wird, wird angenommen dass es der Wert fuer "bubble" ist 
			if (typeof(options) != "object" && options != undefined ) options = {id: options};
			var cfg = $.extend({}, settings, options);
			
			
			$(document).on(cfg.openOn + " " + cfg.closeOn, cfg.selector, function(event) {
				event.preventDefault();    // Oeffnen von Links wird unterbunden
				$('#' + cfg.id).remove();  // Bisherige Tooltipps werden geschlossen
				
				// Wenn das Start-Event getriggert wurde, wird das Tooltipp generiert
				if (event.type == cfg.openOn) {
					var tr     = $(this);
					var pos    = tr.offset();
					var text   = tr.attr(cfg.attr); 
					    text   = cfg.utf8 ? $.utf_decode(text) : text;
					var ttip = $("<div>", {
						id:   cfg.id,
						html: text,
						click: function() {
							$(this).remove();
						}
					}).appendTo('body');
					
					// Unterschiede bezueglich der Positionen
					switch (cfg.position) {
						case "top":
							ttip.addClass("bubble_" + cfg.position);
							var pixelsTop = pos.top - ttip.outerHeight(true) - cfg.arrow; 
							var pixelsLeft = pos.left;
							break;
						case "bottom":
							ttip.addClass("bubble_" + cfg.position);
							var pixelsTop = pos.top + ttip.outerHeight(true) + cfg.arrow;
							var pixelsLeft = pos.left;
							break;
						case "middle":
							ttip.addClass("bubble_" + cfg.position);
							var pixelsTop = pos.top + (tr.innerHeight() / 2) - (ttip.outerHeight(true) / 2);
							var pixelsLeft = pos.left - 280;
							break;
					}
					
					// CSS anwenden
					ttip.css({
						top: pixelsTop,
						left: pixelsLeft
					});
				}
			});
		},
		
		// Laedt die History-Grafiken
		load_pchart: function(options) {
			// Standardsettings,  falls sie nicht im Objekt beim Aufruf mitgegeben wurden
			var settings = {
				divID:  "#ezChart",    // DIV, in das das Chart hineingeladen wird
				loadID: "#ezLoad",     // DIV des Loaders
				defBG:  "stylesheets/images/bg/light60.png", // Standard-Hintergrundbild
				path:   "",            // Pfad zum ezStats Installationsordner
				file:   "history.php", // Datei die den Chart erstellt
				mode:   "score",       // Diagramm da erstellt werden soll
				pid:    false,         // Player-ID des Spielers
				from:   false,         // Start des manuellen Zeitbereichs
				to:     false          // Ende des manuellen Zeitbereichs
			}
			
			// Falls mit den Optionen kein Objekt uebergeben wird, wird angenommen dass es der Wert fuer "pid" ist 
			if (typeof(options) != "object" && options != undefined ) options = {pid: options};
			var cfg = $.extend({}, settings, options);
			
			// Standardwerte
			var url = cfg.path + cfg.file;
			
			// AJAX starten
			$.ajax({
				type:     "GET",
				url:      url,
				data: {
					pid:  cfg.pid,
					mode: cfg.mode,
					from: cfg.from,
					to:   cfg.to
				},
				beforeSend: function() {
					// Loader anzeigen
					$(cfg.loadID).fadeIn();
					
					// Standard-Hintergrundbild setzen
					$(cfg.divID).css({
						backgroundImage: 'url("'+ cfg.path + cfg.defBG + '")',
						backgroundRepeat: 'repeat'
					});
				},
				error: function(data) {
					$.clog("Error loading");
					$.clog(data);
				},
				success:    function(data) {
					// Erzeugen des Dateinamens - die Zufallszahl als Parameter wird benoetigt, um Browsercaching zu verhindern
					var src = cfg.path +'tmp/history'+ cfg.pid +'.png?'+ Math.random();
					
					// Chart als Hintergrundbild anzeigen
					$(cfg.divID).css({
						backgroundImage: 'url("'+ src + '")',
						backgroundRepeat: 'no-repeat'
					});
					
					// Loader ausblenden
					$(cfg.loadID).hide();
				}
			});
		}
	});
})(jQuery);